<?php
/**
	Determines if the user can comment on a suggestion. A user is not allowed to comment on a
	suggestion if they were the last person to comment and it has been less than 5 hours from when
	they last  commented on this suggestion.
	
	@param int suggestion ID
	
	@return boolean
*/
function userCanComment($suggestionId){
	if($_SESSION['admin']==1)
		return 1;

	$select_statement = "SELECT count(*) as count FROM comments WHERE (user_id = '{$_SESSION['user_id']}' AND suggestion_id = '{$suggestionId}' AND DATE_SUB(CURDATE(), INTERVAL 1 HOUR) <= comments.created_on) ";
	$select_query = mysql_query($select_statement)or die (mysql_error());
	
	return ( mysql_result($select_query, 0, 'count') == 0 );
}


/**
	Creates a new comment on the specified suggestion.
	
	@param int suggestion Id
	
	@param comment data
		Array('suggestion_id' => int 
			'name' => String,
			'body' => String
			)
			
	@return Int ID of the created suggestion or 0 if creating the suggestion failed
*/
function postComment($commentData){
	if ( !userCanComment($commentData['suggestion_id']))
		return 0;
	
	foreach($commentData as $element)
		addslashes($element);

	$insert_statement = "INSERT INTO comments (suggestion_id, user_id, created_on, user_name, body) VALUES ('{$commentData['suggestion_id']}', '{$_SESSION['user_id']}', NOW(), '{$commentData['name']}', '{$commentData['body']}')";
	$insert_query = mysql_query($insert_statement) or die ('Could not post comment ' . mysql_error());
	
	return mysql_insert_id();
}

/**
	Retrives all comments associated with the specified suggestion.
	
	@param Int suggestion ID
	
	@return Array List of comment data
		Array(
			Array('id'=>int, 'name'=>String, 'created_on' => DATETIME, 'body' => String);
			...
			Array('id'=>int, 'name'=>String, 'created_on' => DATETIME, 'body' => String);			
		)
*/
function getCommentList($suggestionId){

	$select_statement = "SELECT * FROM comments WHERE suggestion_id = {$suggestionId} ORDER BY created_on ASC";
	$select_query = mysql_query($select_statement) or die (mysql_error());
	
	$commentList = Array();
	
	for($n=0; $n<mysql_numrows($select_query); $n++){
		$comment = Array();
		$comment['id'] = mysql_result($select_query, $n, 'id');
		$comment['name'] = mysql_result($select_query, $n, 'user_name');
		$comment['created_on'] = mysql_result($select_query, $n, 'created_on');
		$comment['body'] = mysql_result($select_query, $n, 'body');
		
		$commentList[]= $comment;
	}
	
	return $commentList;
}

/**
	Updates the comment data.
	
	@param comment data
		Array('id'=> int,
			'name' => String,
			'title' => String,
			'body' => String
			)
*/
function editComment($commentData){
	foreach($commentData as $element)
		addslashes($element);
		
	//Lock the tables just to be safe	
	mysql_query("LOCK TABLES suggestions WRITE");
	
	$update_statement = "UPDATE suggestions SET title='{$suggestionData['title']}', body='{$commentData['body']}', user_name='{$commentData['name']}' WHERE id={$commentData['id']}";
	$update_query = mysql_query($update_statement) or die ('Failed to update suggesion (id=' . $suggestionId . ') ' .mysql_error());
	
	mysql_query("UNLOCK TABLES");
}

/**
	Removes the comment from the database.
	
	@param int comment ID
*/
function deleteComment($commentId){
	//Lock the tables just to be safe
	mysql_query("LOCK TABLES suggestions WRITE, votes WRITE");
	
	$delete_statement = "DELETE FROM comments WHERE id={$commentId} LIMIT 1";
	mysql_query($delete_statement) or die (mysql_error());
	
	mysql_query("UNLOCK TABLES");
}
?>