<?php
/* definition */

	$SuggestionsPerPage = 10;

	$categories = array(
		'top',
		'hardware',
		'software',
		'accessories',
		'store',
		'bugs'
	);
	
/* includes */

	require_once('../../db_functions.php');
	require_once('../../page_functions.php');
	require_once('../../sanitize.php');
	
/* processing the web address with page and category */
/* defaulting to the first page of new suggestions */

	$_SESSION['suggestion_id'] = $suggestion_id = sanitize_int($_GET['suggestion_id']);
	if($suggestion_id <= 0){
		header('Location: ../');
	}

/* load suggestions and comments */
	$suggestion =  getSuggestion($suggestion_id);
	$commentList = getCommentList($suggestion_id);
	
header('Content-type: text/xml');
echo '<?xml version="1.0" encoding="ISO-8859-1"?>';
echo '<rss version="2.0">';

?>

<channel>
<title>Apple's (unofficial) to do list.</title>
<description>What we think Apple should be working on.</description>
<link>http://www.ApplesToDoList.com</link>

<item>
	<title><?=reverse_sanitize_html_string($suggestion['title'])?></title>
	<link>http://www.ApplesToDoList.com/comments/?suggestion_id=<?=$suggestion['id']?></link>
	<description><?=reverse_sanitize_html_string($suggestion['body'])?></description>
	<author><?=reverse_sanitize_html_string($suggestion['name'])?></author>
</item>

<?php foreach($commentList as $key => $comment){ ?>
<item>
	<description><?=reverse_sanitize_html_string($comment['body'])?></description>
	<author><?=reverse_sanitize_html_string($comment['name'])?></author>
</item>
<?php } ?>

</channel>
</rss>
