<?php
/* definition */

	$SuggestionsPerPage = 10;

	$categories = array(
		'top',
		'hardware',
		'software',
		'accessories',
		'store',
		'bugs'
	);
	
/* includes */

	require_once('../db_functions.php');
	require_once('../page_functions.php');
	require_once('../sanitize.php');
	
/* processing the web address with page and category */
/* defaulting to the first page of new suggestions */

	$page = sanitize_int($_GET['page']);
	if($page<0 || !$page){$page = 0;}
	
/* wtf why can't i get this same functionality out of a for loop */

	$category = $_GET['category'];
	if($category == 'newest'){ $category = 0;}
	else if($category == 'hardware'){ $category = 1;}
	else if($category == 'software'){ $category = 2;}
	else if($category == 'accessories'){ $category = 3;}
	else if($category == 'store'){ $category = 4;}
	else if($category == 'bugs'){ $category = 5;}
	else{$category = 0;}
	
/* load proper suggestions from the proper category  */

	if($category == 0){
		$suggestionList = getNewestSuggestionList($page, $SuggestionsPerPage);
		$total_pages = totalPagesOfNewest($SuggestionsPerPage, $category);
	}
	else{
		$suggestionList = getSuggestionList($page, $SuggestionsPerPage, $category);
		$total_pages = totalPages($SuggestionsPerPage, $category);
	}
	
header('Content-type: text/xml');
echo '<?xml version="1.0" encoding="ISO-8859-1"?>';
echo '<rss version="2.0">';

?>

<channel>
<title>Apple's (unofficial) to do list.</title>
<description>What we think Apple should be working on.</description>
<link>http://www.ApplesToDoList.com</link>

<?php foreach($suggestionList as $key => $suggestion){?>
<item>
	<title><?=reverse_sanitize_html_string($suggestion['title'])?></title>
	<link>http://www.ApplesToDoList.com/comments/?suggestion_id=<?=$suggestion['id']?></link>
	<description><?=reverse_sanitize_html_string($suggestion['body'])?></description>
	<author><?=reverse_sanitize_html_string($suggestion['name'])?></author>
</item>
<?php } ?>

</channel>
</rss>
