<?php
/* session_start() and definitions */
	
	session_start();

	$categories = array(
		'newest',
		'hardware',
		'software',
		'accessories',
		'store',
		'bugs'
	);

/* includes */

	require_once('../../db_functions.php');
	require_once('../../sanitize.php');
	
	$category = $_GET['category'];
	if($category == 'hardware'){ $category = 1;}
	else if($category == 'software'){ $category = 2;}
	else if($category == 'accessories'){ $category = 3;}
	else if($category == 'store'){ $category = 4;}
	else if($category == 'bugs'){ $category = 5;}
	else if(!$_SESSION['edit']){header('Location: ../');}


/* processing the web address with category is set to zero by default
if someone seems to be messing with the category in the web address... to punish them
by making their suggestion dissapear when it becomes an old suggestion */
				
	if($_SESSION['edit']){
		$editSuggestion = getSuggestion($_SESSION['suggestion_id']);
		$suggestion_page = floor($suggestion['list_position']/10);
	}
	else{
		$_SESSION['suggestion_id'] = 0;
	}
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">
<html>
	<head>
		<title>submit a suggestion - Apple's (unofficial) to do list.</title>
		<link href="../main_style.css" rel="stylesheet" type="text/css"/>
		<meta name="description" content="Suggestions for Apple Computer" />
		<meta name="keywords" content="Apple Computer, MacBook, MacBook Pro, iMac, Mac mini, Mac Pro, iPod, iPod nano, iPod shuffle, OS X, iLife, iPhoto, iWeb, iMovie HD, iDVD, GarageBand">
	</head>
	<body>
	<div id="contain_everything">
			<div align="center" id="padded">
				<a href="../?page=0&category=new">
					<img src="../images/ATDL.gif" border="0"/>
				</a>
			</div>
			<div align="center" class="center">
				<?php
					if($_SESSION['edit']){echo '<form action="../?page='.$suggestion_page.'&category='.$categories[$editSuggestion['category']].'" method="POST">';}
					else{echo '<form action="../?page=0&category=new_suggestions" method="POST">';}
				?>
				<div align="center" id="submit_suggestion">
					<div class="row">
						<input type="hidden" name="category_id" value="<?php 
							if($_SESSION['edit']){
								echo $editSuggestion['category_id'];
							}
							else{
								echo $category;
							}
						?>" />
						<div class="label">
							<label for="name">name</label>
						</div>
						<div class="form">
							<input name="name" id="name" type="text" tabindex="1" size="25" maxlength="25" value="<?php 
								if($_SESSION['edit']){
									echo $editSuggestion['name'];
								}
								else if($_SESSION['name']){
									echo $_SESSION['name'];
								}
							?>"/>
						</div>
					</div>
					<div class="row">
						<div class="label">
							<label for="title">title</label>
						</div>
						<div class="form">
							<input name="title" id="title" type="text" tabindex="2" size="25" maxlength="50" value="<?php
								if($_SESSION['edit']){
									echo $editSuggestion['title'];
								}
							?>"/>
						</div>
					</div>
					<div class="row">
						<div class="label">
							<label for="body">suggestion</label>
						</div>
						<div class="form">
							<textarea name="body" id="body" tabindex="3" cols="40" rows="10"><?php
								if($_SESSION['edit']){
									echo $editSuggestion['body'];
								}
							?></textarea>
						</div>
					</div>
					<div class="row">
						<div class="button">
							<input type="submit" value="Submit"/>
						</div>
					</div>
				</div>
				</form>
	</div>
	<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
	</script>
		<script type="text/javascript">
		_uacct = "UA-753510-1";
		urchinTracker();
	</script>
	</body>
</html>
<?php
mysql_close();
?>